<?php
/*
    [123imagestock] (C)2006-2007 123imagestock Software. All Rights Reserved.
    This is NOT a freeware, use is subject to license terms
*/
class CommentService
    {
    // database object
    var $_db   = null;
    var $error = null;
    var $table_prefix = null;

    function __construct($db, $table_prefix)
        {
        $this->_db         =$db;
        $this->table_prefix=$table_prefix;
        }

    public function getNum()
        {
        $sql   ="select count(*) as num from " . $this->table_prefix . "comments";
        $result=$this->_db->query($sql);
        $num   =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $num['num'];
        }

    public function checkUpdateForm($data)
        {
        $error=array();

        if (checkBlank($data['headline']))
            {
            $error['comment_headline']=1;
            }

        if (!checkIP($data['ip']))
            {
            $error['comment_ip']=1;
            }

        if (!checkTime($data['date']))
            {
            $error['comment_date']=1;
            }

        return $error;
        }
        
    public function checkPostForm($data)
        {
        $error=array();

        if (checkBlank($data['headline']))
            {
            $error['detail_headline']=1;
            }

        return $error;
        }

    public function save($data)
        {
        if ($_SESSION['auth_code'] == md5($data['validate']))
            {
            $image_id        =$data['id'];
            $user_id         =$_SESSION['userId'];
            $comment_headline=$data['headline'];
            $comment_text    =$data['comment'];
            $comment_ip      =$_SERVER["REMOTE_ADDR"];
            $comment_time    =time();
            $sql             ="insert into " . $this->table_prefix
                . "comments(image_id,user_id,comment_headline,comment_text,comment_ip,comment_date)values('" . $image_id
                . "','" . $user_id . "','" . $comment_headline . "','" . $comment_text . "','" . $comment_ip . "','"
                . $comment_time . "')";
            $result          =$this->_db->query($sql);
            return $result;
            }
            return false;
        }

    public function update($data)
        {
        $comment_id      =$data['id'];
        $comment_headline=$data['headline'];
        $comment_text    =$data['text'];
        $comment_ip      =$data['ip'];
        $data['date']    =timeTrans($data['date']);
        $comment_date    =$data['date'];

        $sql             ="update " . $this->table_prefix . "comments set " . "comment_headline='$comment_headline',"
            . "comment_text='$comment_text'," . "comment_ip='$comment_ip'," . "comment_date='$comment_date'"
            . "where comment_id='$comment_id'";
        $result          =$this->_db->query($sql);
        return $result;
        }

    public function del($ids)
        {
        foreach ($ids as $id)
            {
            $sql   = "delete from " . $this->table_prefix . "comments where comment_id = '$id'";
            $result=$this->_db->query($sql);
            }
        }

    public function searchByAdmin($data)
        {
        $sql         ="select * from " . $this->table_prefix . "comments, " . $this->table_prefix . "images, "
            . $this->table_prefix . "users ";
        $condition='';

        $id_condition='';

        if (trim($data['id']) != '')
            {
            $id_condition.=" comment_id =" . trim($data['id']);
            }

        if ($id_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$id_condition;
                }
            else
                {
                $condition.=" and " . $id_condition;
                }
            }

        $image_id_condition='';

        if (trim($data['image_id']) != '')
            {
            $image_id_condition.=" " . $this->table_prefix . "comments.image_id =" . trim($data['image_id']);
            }

        if ($image_id_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$image_id_condition;
                }
            else
                {
                $condition.=" and " . $image_id_condition;
                }
            }

        $image_name_condition='';
        $terms=preg_split("/[\s]+/", $data['image_name'], -1, PREG_SPLIT_NO_EMPTY);
        $flag=true;

        foreach ($terms as $term)
            {
            if ($flag)
                {
                $image_name_condition.=" image_name like '%" . $term . "%'";
                $flag=false;
                }
            else
                {
                $image_name_condition.=" and image_name like '%" . $term . "%'";
                }
            }

        if ($image_name_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$image_name_condition;
                }
            else
                {
                $condition.=" and " . $image_name_condition;
                }
            }

        $user_id_condition='';

        if (trim($data['user_id']) != '')
            {
            $user_id_condition.=" " . $this->table_prefix . "comments.user_id =" . trim($data['user_id']);
            }

        if ($user_id_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$user_id_condition;
                }
            else
                {
                $condition.=" and " . $user_id_condition;
                }
            }

        $user_name_condition='';
        $terms=preg_split("/[\s]+/", $data['user_name'], -1, PREG_SPLIT_NO_EMPTY);
        $flag=true;

        foreach ($terms as $term)
            {
            if ($flag)
                {
                $user_name_condition.=" user_name like '%" . $term . "%'";
                $flag=false;
                }
            else
                {
                $user_name_condition.=" and user_name like '%" . $term . "%'";
                }
            }

        if ($user_name_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$user_name_condition;
                }
            else
                {
                $condition.=" and " . $user_name_condition;
                }
            }

        $headline_condition='';
        $terms=preg_split("/[\s]+/", $data['headline'], -1, PREG_SPLIT_NO_EMPTY);
        $flag=true;

        foreach ($terms as $term)
            {
            if ($flag)
                {
                $headline_condition.=" comment_headline like '%" . $term . "%'";
                $flag=false;
                }
            else
                {
                $headline_condition.=" and comment_headline like '%" . $term . "%'";
                }
            }

        if ($headline_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$headline_condition;
                }
            else
                {
                $condition.=" and " . $headline_condition;
                }
            }

        $text_condition='';
        $terms         =preg_split("/[\s]+/", $data['text'], -1, PREG_SPLIT_NO_EMPTY);
        $flag          =true;

        foreach ($terms as $term)
            {
            if ($flag)
                {
                $text_condition.=" comment_text like '%" . $term . "%'";
                $flag=false;
                }
            else
                {
                $text_condition.=" and comment_text like '%" . $term . "%'";
                }
            }

        if ($text_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$text_condition;
                }
            else
                {
                $condition.=" and " . $text_condition;
                }
            }

        $dateafter_condition='';
        $data['dateafter']=timeTrans($data['dateafter']);

        if (trim($data['dateafter']) != '')
            {
            $dateafter_condition.=" comment_date >= " . trim($data['dateafter']);
            }

        if ($dateafter_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$dateafter_condition;
                }
            else
                {
                $condition.=" and " . $dateafter_condition;
                }
            }

        $datebefore_condition='';
        $data['datebefore']  =timeTrans($data['datebefore']);

        if (trim($data['datebefore']) != '')
            {
            $datebefore_condition.=" comment_date <= " . trim($data['datebefore']);
            }

        if ($datebefore_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$datebefore_condition;
                }
            else
                {
                $condition.=" and " . $datebefore_condition;
                }
            }

        $sql.=" where " . $this->table_prefix . "comments.image_id = " . $this->table_prefix . "images.image_id and "
            . $this->table_prefix . "comments.user_id = " . $this->table_prefix . "users.user_id ";

        if ($condition != '')
            {
            $sql.=" and " . $condition;
            }

        switch ($data['sortby'])
            {
            case "image_name":
                $sql.=" order by image_name " . $data['direction'];

                break;

            case "user_name":
                $sql.=" order by user_name " . $data['direction'];

                break;

            case "headline":
                $sql.=" order by comment_headline " . $data['direction'];

                break;

            case "date":
                $sql.=" order by comment_date " . $data['direction'];

                break;
            }

        $result=$this->_db->query($sql);
        $num=$this->_db->get_numrows($result);
        $sql.=" limit " . ($data['requestpage'] - 1) * $data['rows_per_page'] . " , " . ($data['rows_per_page']);
        $result  =$this->_db->query($sql);
        $comments=$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        $pagecount =ceil($num / ($data['rows_per_page']));
        $navigation=create_navigation($pagecount, $data['requestpage']);
        return array
            (
            "nav"      => $navigation,
            "comments" => $comments
            );
        }
        
    public function delUsers($userId)
    {
            $sql   = "delete from ".$this->table_prefix."comments where user_id = '$userId'";
            $result=$this->_db->query($sql);
    }
        
    public function delImages($imageId)
    {
            $sql   = "delete from ".$this->table_prefix."comments where image_id = '$imageId'";
            $result=$this->_db->query($sql);
    }

    public function searchById($commentId)
        {
        $sql    ="select * from " . $this->table_prefix . "comments where comment_id=" . $commentId;
        $result =$this->_db->query($sql);
        $comment=$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $comment;
        }

    public function searchByImageId($imageId)
        {
        $sql     ="select * from " . $this->table_prefix . "comments," . $this->table_prefix . "users where image_id="
            . $imageId . " and " . $this->table_prefix . "comments.user_id = " . $this->table_prefix
            . "users.user_id order by comment_date desc";
        $result  =$this->_db->query($sql);
        $comments=$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $comments;
        }
    }
?>